<template>
  <MainTemplate>
    <template #headerInsert>
      <RouterLink to="../" class="text-primary">zurück zur Liste (abbrechen)</RouterLink>
    </template>
    <template #topBar>
      <div class="flex flex-row items-center justify-between pt-5 pb-3 px-7">
        <h1 class="font-bold text-xl h-8">Nutzer {{ origin?.username }} - Daten bearbeiten</h1>
      </div>
    </template>
    <template #main>
      <Spinner v-if="loading == 'loading'" class="mx-auto" />
      <p v-else-if="loading == 'failed'">laden fehlgeschlagen</p>
      <form
        v-else-if="user != null"
        class="flex flex-col gap-4 py-2 w-full max-w-xl mx-auto"
        @submit.prevent="triggerUpdateUser"
      >
        <div>
          <label for="username">Nutzername</label>
          <input type="text" id="username" required v-model="user.username" />
        </div>
        <div>
          <label for="firstname">Vorname</label>
          <input type="text" id="firstname" required v-model="user.firstname" />
        </div>
        <div>
          <label for="lastname">Nachname</label>
          <input type="text" id="lastname" required v-model="user.lastname" />
        </div>
        <div>
          <label for="mail">Mailadresse</label>
          <input type="email" id="mail" required v-model="user.mail" />
        </div>
        <div class="flex flex-row justify-end gap-2">
          <button primary-outline type="reset" class="!w-fit" :disabled="canSaveOrReset" @click="resetForm">
            verwerfen
          </button>
          <button primary type="submit" class="!w-fit" :disabled="status == 'loading' || canSaveOrReset">
            speichern
          </button>
          <Spinner v-if="status == 'loading'" class="my-auto" />
          <SuccessCheckmark v-else-if="status?.status == 'success'" />
          <FailureXMark v-else-if="status?.status == 'failed'" />
        </div>
      </form>
    </template>
  </MainTemplate>
</template>

<script setup lang="ts">
import { defineComponent } from "vue";
import { mapState, mapActions } from "pinia";
import MainTemplate from "@/templates/Main.vue";
import Spinner from "@/components/Spinner.vue";
import SuccessCheckmark from "@/components/SuccessCheckmark.vue";
import FailureXMark from "@/components/FailureXMark.vue";
import { RouterLink } from "vue-router";
import { useUserStore } from "@/stores/admin/user";
import type { UpdateUserViewModel, UserViewModel } from "@/viewmodels/admin/user.models";
import cloneDeep from "lodash.clonedeep";
import isEqual from "lodash.isequal";
</script>

<script lang="ts">
export default defineComponent({
  props: {
    id: String,
  },
  data() {
    return {
      loading: "loading" as "loading" | "fetched" | "failed",
      status: null as null | "loading" | { status: "success" | "failed"; reason?: string },
      origin: null as null | UserViewModel,
      user: null as null | UserViewModel,
      timeout: null as any,
    };
  },
  computed: {
    canSaveOrReset(): boolean {
      return isEqual(this.origin, this.user);
    },
  },
  mounted() {
    this.fetchItem();
  },
  beforeUnmount() {
    try {
      clearTimeout(this.timeout);
    } catch (error) {}
  },
  methods: {
    ...mapActions(useUserStore, ["fetchUserById", "updateActiveUser"]),
    resetForm() {
      this.user = cloneDeep(this.origin);
    },
    fetchItem() {
      this.fetchUserById(parseInt(this.id ?? ""))
        .then((result) => {
          this.user = result.data;
          this.origin = cloneDeep(result.data);
          this.loading = "fetched";
        })
        .catch((err) => {
          this.loading = "failed";
        });
    },
    triggerUpdateUser(e: any) {
      if (this.user == null) return;
      let formData = e.target.elements;
      let user: UpdateUserViewModel = {
        id: this.user.id,
        username: formData.username.value,
        firstname: formData.firstname.value,
        lastname: formData.lastname.value,
        mail: formData.mail.value,
      };
      this.status = "loading";
      this.updateActiveUser(user)
        .then(() => {
          this.fetchItem();
          this.status = { status: "success" };
        })
        .catch((err) => {
          this.status = { status: "failed" };
        })
        .finally(() => {
          this.timeout = setTimeout(() => {
            this.status = null;
          }, 2000);
        });
    },
  },
});
</script>
